# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.91"
name = "blueprint-auth"
version = "0.2.0-alpha.5"
authors = ["Tangle Network"]
build = "build.rs"
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Blueprint HTTP/WS Authentication"
homepage = "https://tangle.tools"
readme = "README.md"
license = "MIT OR Apache-2.0"
repository = "https://github.com/tangle-network/blueprint"

[features]
default = [
    "std",
    "tracing",
]
standalone = [
    "tempfile",
    "axum/http1",
    "axum/http2",
    "axum/tokio",
]
std = [
    "blueprint-std/std",
    "crc32fast/std",
    "k256/std",
    "schnorrkel/std",
    "base64/std",
    "prost/std",
    "blueprint-crypto/std",
]
tracing = []

[lib]
name = "blueprint_auth"
path = "src/lib.rs"

[[bin]]
name = "auth-server"
path = "src/main.rs"
required-features = ["standalone"]

[dependencies.axum]
version = "0.8"
features = [
    "json",
    "form",
    "http1",
    "http2",
    "tokio",
]
default-features = false

[dependencies.base64]
version = "0.22.0"
features = ["alloc"]
default-features = false

[dependencies.blueprint-core]
version = "0.2.0-alpha.4"
features = ["tracing"]
default-features = false

[dependencies.blueprint-crypto]
version = "0.2.0-alpha.5"
features = ["bn254"]
default-features = false

[dependencies.blueprint-std]
version = "0.2.0-alpha.4"
default-features = false

[dependencies.chacha20poly1305]
version = "0.10.1"
features = [
    "alloc",
    "getrandom",
]
default-features = false

[dependencies.crc32fast]
version = "1.5"
default-features = false

[dependencies.hashbrown]
version = "0.16.1"
features = [
    "default-hasher",
    "inline-more",
]
default-features = false

[dependencies.hex]
version = "0.4.3"
features = [
    "serde",
    "alloc",
]
default-features = false

[dependencies.hyper]
version = "1.6.0"
features = ["full"]
default-features = false

[dependencies.hyper-rustls]
version = "0.27.7"
features = [
    "http2",
    "ring",
]
default-features = false

[dependencies.hyper-util]
version = "0.1"
features = [
    "client",
    "client-legacy",
    "tokio",
    "http2",
    "server",
]
default-features = false

[dependencies.jsonwebtoken]
version = "9"
default-features = false

[dependencies.k256]
version = "0.13.3"
features = [
    "ecdsa",
    "alloc",
    "serde",
    "pem",
]
default-features = false

[dependencies.once_cell]
version = "1.19.0"
features = ["std"]
default-features = false

[dependencies.pasetors]
version = "0.7.7"
features = [
    "v4",
    "serde_json",
    "std",
]
default-features = false

[dependencies.pem]
version = "3.0"
default-features = false

[dependencies.prost]
version = "0.13"
features = ["derive"]
default-features = false

[dependencies.rcgen]
version = "0.14.7"
features = [
    "pem",
    "crypto",
    "ring",
    "pem",
    "x509-parser",
]
default-features = false

[dependencies.rocksdb]
version = "0.21.0"
features = ["lz4"]
default-features = false

[dependencies.rustls]
version = "0.23.31"
features = [
    "std",
    "default",
]
default-features = false

[dependencies.rustls-pemfile]
version = "2.2.0"
features = ["std"]
default-features = false

[dependencies.schnorrkel]
version = "0.11.5"
default-features = false

[dependencies.serde]
version = "1.0.208"
features = [
    "derive",
    "alloc",
]
default-features = false

[dependencies.serde_json]
version = "1.0"
default-features = false

[dependencies.subtle]
version = "2"
default-features = false

[dependencies.tempfile]
version = "3.25.0"
optional = true
default-features = false

[dependencies.thiserror]
version = "2.0.17"
default-features = false

[dependencies.time]
version = "0.3.41"
default-features = false

[dependencies.tiny-keccak]
version = "2.0.2"
features = ["keccak"]
default-features = false

[dependencies.tokio]
version = "^1"
features = ["full"]
default-features = false

[dependencies.tokio-rustls]
version = "0.26.2"
features = [
    "tls12",
    "default",
]
default-features = false

[dependencies.tower]
version = "0.5.2"
features = ["util"]
default-features = false

[dependencies.tower-http]
version = "0.6"
features = [
    "cors",
    "request-id",
    "sensitive-headers",
    "trace",
]
default-features = false

[dependencies.tracing]
version = "0.1"
features = ["attributes"]
default-features = false

[dependencies.uuid]
version = "1.22.0"
features = [
    "v4",
    "serde",
]
default-features = false

[dependencies.x509-parser]
version = "0.18.0"

[dev-dependencies.axum]
version = "0.8"
features = [
    "json",
    "multipart",
    "http1",
    "http2",
    "tokio",
]
default-features = false

[dev-dependencies.bytes]
version = "1.10.1"
default-features = false

[dev-dependencies.futures-util]
version = "0.3.31"
default-features = false

[dev-dependencies.http]
version = "1.0.0"
default-features = false

[dev-dependencies.hyper-rustls]
version = "0.27.7"
features = [
    "http2",
    "ring",
]
default-features = false

[dev-dependencies.openssl]
version = "0.10"
features = ["vendored"]
default-features = false

[dev-dependencies.rcgen]
version = "0.14.7"
features = ["pem"]
default-features = false

[dev-dependencies.reqwest]
version = "0.12.22"
features = [
    "json",
    "multipart",
]
default-features = false

[dev-dependencies.rustls]
version = "0.23.31"
features = ["std"]
default-features = false

[dev-dependencies.rustls-pemfile]
version = "2.2.0"
default-features = false

[dev-dependencies.serde_json]
version = "1.0"
features = ["alloc"]
default-features = false

[dev-dependencies.tempfile]
version = "3.25.0"
default-features = false

[dev-dependencies.tokio]
version = "^1"
features = ["full"]
default-features = false

[dev-dependencies.tokio-rustls]
version = "0.26.2"
features = ["tls12"]
default-features = false

[dev-dependencies.tokio-stream]
version = "0.1.15"
features = ["net"]
default-features = false

[dev-dependencies.tonic]
version = "0.13.1"
features = [
    "tls-webpki-roots",
    "codegen",
    "prost",
    "transport",
]
default-features = false

[dev-dependencies.tower]
version = "0.5.2"
features = [
    "util",
    "timeout",
    "limit",
    "load-shed",
    "steer",
    "filter",
    "make",
]
default-features = false

[dev-dependencies.tracing-subscriber]
version = "0.3"
features = [
    "fmt",
    "env-filter",
    "registry",
]
default-features = false

[build-dependencies.protobuf-src]
version = "2.1"

[build-dependencies.tonic-build]
version = "0.13.1"
features = [
    "prost",
    "transport",
]
default-features = false

[lints.clippy]
assigning_clones = "allow"
bool_to_int_with_if = "allow"
cast_lossless = "allow"
cast_possible_truncation = "allow"
cast_possible_wrap = "allow"
cast_precision_loss = "allow"
cast_sign_loss = "allow"
cloned_instead_of_copied = "allow"
collapsible_else_if = "allow"
collapsible_if = "allow"
comparison_chain = "allow"
default_trait_access = "allow"
derivable_impls = "allow"
diverging_sub_expression = "allow"
doc_markdown = "allow"
double_must_use = "allow"
duplicated_attributes = "allow"
explicit_iter_loop = "allow"
field_reassign_with_default = "allow"
fn_params_excessive_bools = "allow"
format_push_string = "allow"
if_not_else = "allow"
ignore_without_reason = "allow"
ignored_unit_patterns = "allow"
implicit_clone = "allow"
implicit_hasher = "allow"
inconsistent_struct_constructor = "allow"
items_after_statements = "allow"
large_enum_variant = "allow"
large_futures = "allow"
manual_div_ceil = "allow"
manual_inspect = "allow"
manual_let_else = "allow"
manual_range_contains = "allow"
manual_string_new = "allow"
map_unwrap_or = "allow"
match_same_arms = "allow"
match_wildcard_for_single_variants = "allow"
missing_errors_doc = "allow"
missing_fields_in_debug = "allow"
missing_panics_doc = "allow"
must_use_candidate = "allow"
needless_borrows_for_generic_args = "allow"
needless_continue = "allow"
needless_pass_by_value = "allow"
needless_raw_string_hashes = "allow"
no_effect_underscore_binding = "allow"
option_as_ref_cloned = "allow"
print_literal = "allow"
redundant_closure = "allow"
redundant_closure_for_method_calls = "allow"
redundant_else = "allow"
redundant_slicing = "allow"
result_large_err = "allow"
return_self_not_must_use = "allow"
semicolon_if_nothing_returned = "allow"
similar_names = "allow"
single_char_pattern = "allow"
single_match_else = "allow"
struct_excessive_bools = "allow"
too_many_arguments = "allow"
too_many_lines = "allow"
transmute_ptr_to_ptr = "allow"
trivially_copy_pass_by_ref = "allow"
type_complexity = "allow"
unchecked_duration_subtraction = "allow"
uninlined_format_args = "allow"
unnecessary_debug_formatting = "allow"
unnecessary_filter_map = "allow"
unnecessary_map_or = "allow"
unnecessary_wraps = "allow"
unnested_or_patterns = "allow"
unreadable_literal = "allow"
unused_async = "allow"
unused_self = "allow"
used_underscore_binding = "allow"
wildcard_imports = "allow"
wrong_self_convention = "allow"

[lints.clippy.all]
level = "deny"
priority = -1

[lints.clippy.pedantic]
level = "deny"
priority = -1

[lints.rust]
async_fn_in_trait = "allow"
elided_lifetimes_in_paths = "allow"
trivial_casts = "allow"
trivial_numeric_casts = "allow"
unused_import_braces = "deny"

[lints.rust.rust_2018_idioms]
level = "deny"
priority = -1

[lints.rustdoc]
broken_intra_doc_links = "deny"
